/* Color.c generated by valac 0.40.11, the Vala compiler
 * generated from Color.vala, do not modify */

/**/
/*  Copyright (C) 2011 Robert Dyer*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/


#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>


#define PLANK_TYPE_COLOR (plank_color_get_type ())
typedef GdkRGBA PlankColor;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);



GType plank_color_get_type (void) G_GNUC_CONST;
PlankColor* plank_color_dup (const PlankColor* self);
void plank_color_free (PlankColor* self);
void plank_color_from_hsv (gdouble h,
                           gdouble s,
                           gdouble v,
                           PlankColor* result);
void plank_color_set_hsv (PlankColor *self,
                          gdouble h,
                          gdouble s,
                          gdouble v);
void plank_color_from_hsl (gdouble h,
                           gdouble s,
                           gdouble l,
                           PlankColor* result);
void plank_color_set_hsl (PlankColor *self,
                          gdouble h,
                          gdouble s,
                          gdouble v);
static void plank_color_hsv_to_rgb (gdouble h,
                             gdouble s,
                             gdouble v,
                             gdouble* r,
                             gdouble* g,
                             gdouble* b);
void plank_color_set_hue (PlankColor *self,
                          gdouble hue);
static void plank_color_rgb_to_hsv (gdouble r,
                             gdouble g,
                             gdouble b,
                             gdouble* h,
                             gdouble* s,
                             gdouble* v);
void plank_color_set_sat (PlankColor *self,
                          gdouble sat);
void plank_color_set_val (PlankColor *self,
                          gdouble val);
void plank_color_get_hsv (PlankColor *self,
                          gdouble* h,
                          gdouble* s,
                          gdouble* v);
gdouble plank_color_get_hue (PlankColor *self);
gdouble plank_color_get_sat (PlankColor *self);
gdouble plank_color_get_val (PlankColor *self);
void plank_color_add_hue (PlankColor *self,
                          gdouble val);
void plank_color_set_min_sat (PlankColor *self,
                              gdouble sat);
void plank_color_set_min_val (PlankColor *self,
                              gdouble val);
void plank_color_set_max_sat (PlankColor *self,
                              gdouble sat);
void plank_color_set_max_val (PlankColor *self,
                              gdouble val);
void plank_color_multiply_sat (PlankColor *self,
                               gdouble amount);
void plank_color_brighten_val (PlankColor *self,
                               gdouble amount);
void plank_color_darken_val (PlankColor *self,
                             gdouble amount);
void plank_color_darken_by_sat (PlankColor *self,
                                gdouble amount);
void plank_color_get_hsl (PlankColor *self,
                          gdouble* h,
                          gdouble* s,
                          gdouble* l);
static void plank_color_rgb_to_hsl (gdouble r,
                             gdouble g,
                             gdouble b,
                             gdouble* h,
                             gdouble* s,
                             gdouble* l);
static void plank_color_hsl_to_rgb (gdouble h,
                             gdouble s,
                             gdouble l,
                             gdouble* r,
                             gdouble* g,
                             gdouble* b);
gchar* plank_color_to_prefs_string (PlankColor *self);
void plank_color_from_prefs_string (const gchar* s,
                                    PlankColor* result);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
 * Create new color for the given HSV values while
 * h in [0,360), s in [0,1] and v in [0,1]
 *
 * @param h the hue for the color
 * @param s the saturation for the color
 * @param v the value for the color
 * @return new {@link Color} based on the HSV values
 */
void
plank_color_from_hsv (gdouble h,
                      gdouble s,
                      gdouble v,
                      PlankColor* result)
{
	PlankColor _result_ = {0};
	PlankColor _tmp0_ = {0};
	_tmp0_.red = 1.0;
	_tmp0_.green = 1.0;
	_tmp0_.blue = 1.0;
	_tmp0_.alpha = 1.0;
	_result_ = _tmp0_;
	plank_color_set_hsv (&_result_, h, s, v);
	*result = _result_;
	return;
}


/**
 * Create new color for the given HSL values while
 * h in [0,360), s in [0,1] and l in [0,1]
 *
 * @param h the hue for the color
 * @param s the saturation for the color
 * @param l the lightness for the color
 * @return new {@link Color} based on the HSL values
 */
void
plank_color_from_hsl (gdouble h,
                      gdouble s,
                      gdouble l,
                      PlankColor* result)
{
	PlankColor _result_ = {0};
	PlankColor _tmp0_ = {0};
	_tmp0_.red = 1.0;
	_tmp0_.green = 1.0;
	_tmp0_.blue = 1.0;
	_tmp0_.alpha = 1.0;
	_result_ = _tmp0_;
	plank_color_set_hsl (&_result_, h, s, l);
	*result = _result_;
	return;
}


/**
 * Set HSV color values of this color.
 */
void
plank_color_set_hsv (PlankColor *self,
                     gdouble h,
                     gdouble s,
                     gdouble v)
{
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	plank_color_hsv_to_rgb (h, s, v, &_tmp0_, &_tmp1_, &_tmp2_);
	(*self).red = _tmp0_;
	(*self).green = _tmp1_;
	(*self).blue = _tmp2_;
}


/**
 * Sets the hue for the color.
 *
 * @param hue the new hue for the color
 */
void
plank_color_set_hue (PlankColor *self,
                     gdouble hue)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	_vala_return_if_fail ((hue >= ((gdouble) 0)) && (hue <= ((gdouble) 360)), "hue >= 0 && hue <= 360");
	_tmp0_ = (*self).red;
	_tmp1_ = (*self).green;
	_tmp2_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	h = _tmp3_;
	s = _tmp4_;
	v = _tmp5_;
	h = hue;
	_tmp6_ = h;
	plank_color_hsv_to_rgb (_tmp6_, s, v, &_tmp7_, &_tmp8_, &_tmp9_);
	(*self).red = _tmp7_;
	(*self).green = _tmp8_;
	(*self).blue = _tmp9_;
}


/**
 * Sets the saturation for the color.
 *
 * @param sat the new saturation for the color
 */
void
plank_color_set_sat (PlankColor *self,
                     gdouble sat)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	_vala_return_if_fail ((sat >= ((gdouble) 0)) && (sat <= ((gdouble) 1)), "sat >= 0 && sat <= 1");
	_tmp0_ = (*self).red;
	_tmp1_ = (*self).green;
	_tmp2_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	h = _tmp3_;
	s = _tmp4_;
	v = _tmp5_;
	s = sat;
	_tmp6_ = s;
	plank_color_hsv_to_rgb (h, _tmp6_, v, &_tmp7_, &_tmp8_, &_tmp9_);
	(*self).red = _tmp7_;
	(*self).green = _tmp8_;
	(*self).blue = _tmp9_;
}


/**
 * Sets the value for the color.
 *
 * @param val the new value for the color
 */
void
plank_color_set_val (PlankColor *self,
                     gdouble val)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	_vala_return_if_fail ((val >= ((gdouble) 0)) && (val <= ((gdouble) 1)), "val >= 0 && val <= 1");
	_tmp0_ = (*self).red;
	_tmp1_ = (*self).green;
	_tmp2_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	h = _tmp3_;
	s = _tmp4_;
	v = _tmp5_;
	v = val;
	_tmp6_ = v;
	plank_color_hsv_to_rgb (h, s, _tmp6_, &_tmp7_, &_tmp8_, &_tmp9_);
	(*self).red = _tmp7_;
	(*self).green = _tmp8_;
	(*self).blue = _tmp9_;
}


/**
 * Get HSV color values of this color.
 */
void
plank_color_get_hsv (PlankColor *self,
                     gdouble* h,
                     gdouble* s,
                     gdouble* v)
{
	gdouble _vala_h = 0.0;
	gdouble _vala_s = 0.0;
	gdouble _vala_v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	_tmp0_ = (*self).red;
	_tmp1_ = (*self).green;
	_tmp2_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	_vala_h = _tmp3_;
	_vala_s = _tmp4_;
	_vala_v = _tmp5_;
	if (h) {
		*h = _vala_h;
	}
	if (s) {
		*s = _vala_s;
	}
	if (v) {
		*v = _vala_v;
	}
}


/**
 * Returns the hue for the color.
 *
 * @return the hue for the color
 */
gdouble
plank_color_get_hue (PlankColor *self)
{
	gdouble result = 0.0;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	_tmp0_ = (*self).red;
	_tmp1_ = (*self).green;
	_tmp2_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	h = _tmp3_;
	s = _tmp4_;
	v = _tmp5_;
	result = h;
	return result;
}


/**
 * Returns the saturation for the color.
 *
 * @return the saturation for the color
 */
gdouble
plank_color_get_sat (PlankColor *self)
{
	gdouble result = 0.0;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	_tmp0_ = (*self).red;
	_tmp1_ = (*self).green;
	_tmp2_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	h = _tmp3_;
	s = _tmp4_;
	v = _tmp5_;
	result = s;
	return result;
}


/**
 * Returns the value for the color.
 *
 * @return the value for the color
 */
gdouble
plank_color_get_val (PlankColor *self)
{
	gdouble result = 0.0;
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	_tmp0_ = (*self).red;
	_tmp1_ = (*self).green;
	_tmp2_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	h = _tmp3_;
	s = _tmp4_;
	v = _tmp5_;
	result = v;
	return result;
}


/**
 * Increases the color's hue.
 *
 * @param val the amount to add to the hue
 */
void
plank_color_add_hue (PlankColor *self,
                     gdouble val)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	_tmp0_ = (*self).red;
	_tmp1_ = (*self).green;
	_tmp2_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	h = _tmp3_;
	s = _tmp4_;
	v = _tmp5_;
	_tmp6_ = h;
	h = fmod (fmod (_tmp6_ + val, 360) + 360, 360);
	_tmp7_ = h;
	plank_color_hsv_to_rgb (_tmp7_, s, v, &_tmp8_, &_tmp9_, &_tmp10_);
	(*self).red = _tmp8_;
	(*self).green = _tmp9_;
	(*self).blue = _tmp10_;
}


/**
 * Assures the color's saturation is greater than or equal to the given one.
 *
 * @param sat the minimum saturation
 */
void
plank_color_set_min_sat (PlankColor *self,
                         gdouble sat)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	_vala_return_if_fail ((sat >= ((gdouble) 0)) && (sat <= ((gdouble) 1)), "sat >= 0 && sat <= 1");
	_tmp0_ = (*self).red;
	_tmp1_ = (*self).green;
	_tmp2_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	h = _tmp3_;
	s = _tmp4_;
	v = _tmp5_;
	_tmp6_ = s;
	s = MAX (_tmp6_, sat);
	_tmp7_ = s;
	plank_color_hsv_to_rgb (h, _tmp7_, v, &_tmp8_, &_tmp9_, &_tmp10_);
	(*self).red = _tmp8_;
	(*self).green = _tmp9_;
	(*self).blue = _tmp10_;
}


/**
 * Assures the color's value is greater than or equal to the given one.
 *
 * @param val the minimum value
 */
void
plank_color_set_min_val (PlankColor *self,
                         gdouble val)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	_vala_return_if_fail ((val >= ((gdouble) 0)) && (val <= ((gdouble) 1)), "val >= 0 && val <= 1");
	_tmp0_ = (*self).red;
	_tmp1_ = (*self).green;
	_tmp2_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	h = _tmp3_;
	s = _tmp4_;
	v = _tmp5_;
	_tmp6_ = v;
	v = MAX (_tmp6_, val);
	_tmp7_ = v;
	plank_color_hsv_to_rgb (h, s, _tmp7_, &_tmp8_, &_tmp9_, &_tmp10_);
	(*self).red = _tmp8_;
	(*self).green = _tmp9_;
	(*self).blue = _tmp10_;
}


/**
 * Assures the color's saturation is less than or equal to the given one.
 *
 * @param sat the maximum saturation
 */
void
plank_color_set_max_sat (PlankColor *self,
                         gdouble sat)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	_vala_return_if_fail ((sat >= ((gdouble) 0)) && (sat <= ((gdouble) 1)), "sat >= 0 && sat <= 1");
	_tmp0_ = (*self).red;
	_tmp1_ = (*self).green;
	_tmp2_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	h = _tmp3_;
	s = _tmp4_;
	v = _tmp5_;
	_tmp6_ = s;
	s = MIN (_tmp6_, sat);
	_tmp7_ = s;
	plank_color_hsv_to_rgb (h, _tmp7_, v, &_tmp8_, &_tmp9_, &_tmp10_);
	(*self).red = _tmp8_;
	(*self).green = _tmp9_;
	(*self).blue = _tmp10_;
}


/**
 * Assures the color's value is less than or equal to the given one.
 *
 * @param val the maximum value
 */
void
plank_color_set_max_val (PlankColor *self,
                         gdouble val)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	_vala_return_if_fail ((val >= ((gdouble) 0)) && (val <= ((gdouble) 1)), "val >= 0 && val <= 1");
	_tmp0_ = (*self).red;
	_tmp1_ = (*self).green;
	_tmp2_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	h = _tmp3_;
	s = _tmp4_;
	v = _tmp5_;
	_tmp6_ = v;
	v = MIN (_tmp6_, val);
	_tmp7_ = v;
	plank_color_hsv_to_rgb (h, s, _tmp7_, &_tmp8_, &_tmp9_, &_tmp10_);
	(*self).red = _tmp8_;
	(*self).green = _tmp9_;
	(*self).blue = _tmp10_;
}


/**
 * Multiplies the color's saturation using the amount.
 *
 * @param amount amount to multiply the saturation by
 */
void
plank_color_multiply_sat (PlankColor *self,
                          gdouble amount)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	_vala_return_if_fail (amount >= ((gdouble) 0), "amount >= 0");
	_tmp0_ = (*self).red;
	_tmp1_ = (*self).green;
	_tmp2_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	h = _tmp3_;
	s = _tmp4_;
	v = _tmp5_;
	_tmp6_ = s;
	s = MIN ((gdouble) 1, _tmp6_ * amount);
	_tmp7_ = s;
	plank_color_hsv_to_rgb (h, _tmp7_, v, &_tmp8_, &_tmp9_, &_tmp10_);
	(*self).red = _tmp8_;
	(*self).green = _tmp9_;
	(*self).blue = _tmp10_;
}


/**
 * Brighten the color's value using the value.
 *
 * @param amount percent of the value to brighten by
 */
void
plank_color_brighten_val (PlankColor *self,
                          gdouble amount)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	_vala_return_if_fail ((amount >= ((gdouble) 0)) && (amount <= ((gdouble) 1)), "amount >= 0 && amount <= 1");
	_tmp0_ = (*self).red;
	_tmp1_ = (*self).green;
	_tmp2_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	h = _tmp3_;
	s = _tmp4_;
	v = _tmp5_;
	_tmp6_ = v;
	_tmp7_ = v;
	v = MIN ((gdouble) 1, _tmp6_ + ((1 - _tmp7_) * amount));
	_tmp8_ = v;
	plank_color_hsv_to_rgb (h, s, _tmp8_, &_tmp9_, &_tmp10_, &_tmp11_);
	(*self).red = _tmp9_;
	(*self).green = _tmp10_;
	(*self).blue = _tmp11_;
}


/**
 * Darkens the color's value using the value.
 *
 * @param amount percent of the value to darken by
 */
void
plank_color_darken_val (PlankColor *self,
                        gdouble amount)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	_vala_return_if_fail ((amount >= ((gdouble) 0)) && (amount <= ((gdouble) 1)), "amount >= 0 && amount <= 1");
	_tmp0_ = (*self).red;
	_tmp1_ = (*self).green;
	_tmp2_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	h = _tmp3_;
	s = _tmp4_;
	v = _tmp5_;
	_tmp6_ = v;
	_tmp7_ = v;
	v = MAX ((gdouble) 0, _tmp6_ - ((1 - _tmp7_) * amount));
	_tmp8_ = v;
	plank_color_hsv_to_rgb (h, s, _tmp8_, &_tmp9_, &_tmp10_, &_tmp11_);
	(*self).red = _tmp9_;
	(*self).green = _tmp10_;
	(*self).blue = _tmp11_;
}


/**
 * Darkens the color's value using the saturtion.
 *
 * @param amount percent of the saturation to darken by
 */
void
plank_color_darken_by_sat (PlankColor *self,
                           gdouble amount)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	_vala_return_if_fail ((amount >= ((gdouble) 0)) && (amount <= ((gdouble) 1)), "amount >= 0 && amount <= 1");
	_tmp0_ = (*self).red;
	_tmp1_ = (*self).green;
	_tmp2_ = (*self).blue;
	plank_color_rgb_to_hsv (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	h = _tmp3_;
	s = _tmp4_;
	v = _tmp5_;
	_tmp6_ = v;
	v = MAX ((gdouble) 0, _tmp6_ - (amount * s));
	_tmp7_ = v;
	plank_color_hsv_to_rgb (h, s, _tmp7_, &_tmp8_, &_tmp9_, &_tmp10_);
	(*self).red = _tmp8_;
	(*self).green = _tmp9_;
	(*self).blue = _tmp10_;
}


/**
 * Get HSL color values of this color.
 */
void
plank_color_get_hsl (PlankColor *self,
                     gdouble* h,
                     gdouble* s,
                     gdouble* l)
{
	gdouble _vala_h = 0.0;
	gdouble _vala_s = 0.0;
	gdouble _vala_l = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	_tmp0_ = (*self).red;
	_tmp1_ = (*self).green;
	_tmp2_ = (*self).blue;
	plank_color_rgb_to_hsl (_tmp0_, _tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	_vala_h = _tmp3_;
	_vala_s = _tmp4_;
	_vala_l = _tmp5_;
	if (h) {
		*h = _vala_h;
	}
	if (s) {
		*s = _vala_s;
	}
	if (l) {
		*l = _vala_l;
	}
}


/**
 * Set HSL color values of this color.
 */
void
plank_color_set_hsl (PlankColor *self,
                     gdouble h,
                     gdouble s,
                     gdouble v)
{
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	plank_color_hsl_to_rgb (h, s, v, &_tmp0_, &_tmp1_, &_tmp2_);
	(*self).red = _tmp0_;
	(*self).green = _tmp1_;
	(*self).blue = _tmp2_;
}


static void
plank_color_rgb_to_hsv (gdouble r,
                        gdouble g,
                        gdouble b,
                        gdouble* h,
                        gdouble* s,
                        gdouble* v)
{
	gdouble _vala_h = 0.0;
	gdouble _vala_s = 0.0;
	gdouble _vala_v = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble min = 0.0;
	gdouble max = 0.0;
	gdouble delta = 0.0;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	_vala_return_if_fail ((r >= ((gdouble) 0)) && (r <= ((gdouble) 1)), "r >= 0 && r <= 1");
	_vala_return_if_fail ((g >= ((gdouble) 0)) && (g <= ((gdouble) 1)), "g >= 0 && g <= 1");
	_vala_return_if_fail ((b >= ((gdouble) 0)) && (b <= ((gdouble) 1)), "b >= 0 && b <= 1");
	_vala_v = MAX (r, MAX (g, b));
	_tmp0_ = _vala_v;
	if (_tmp0_ == ((gdouble) 0)) {
		_vala_h = (gdouble) 0;
		_vala_s = (gdouble) 0;
		if (h) {
			*h = _vala_h;
		}
		if (s) {
			*s = _vala_s;
		}
		if (v) {
			*v = _vala_v;
		}
		return;
	}
	_tmp1_ = _vala_v;
	r = r / _tmp1_;
	_tmp2_ = _vala_v;
	g = g / _tmp2_;
	_tmp3_ = _vala_v;
	b = b / _tmp3_;
	min = MIN (r, MIN (g, b));
	max = MAX (r, MAX (g, b));
	_tmp4_ = max;
	_tmp5_ = min;
	delta = _tmp4_ - _tmp5_;
	_tmp6_ = delta;
	_vala_s = _tmp6_;
	_tmp7_ = _vala_s;
	if (_tmp7_ == ((gdouble) 0)) {
		_vala_h = (gdouble) 0;
		if (h) {
			*h = _vala_h;
		}
		if (s) {
			*s = _vala_s;
		}
		if (v) {
			*v = _vala_v;
		}
		return;
	}
	_tmp8_ = min;
	_tmp9_ = delta;
	r = (r - _tmp8_) / _tmp9_;
	_tmp10_ = min;
	_tmp11_ = delta;
	g = (g - _tmp10_) / _tmp11_;
	_tmp12_ = min;
	_tmp13_ = delta;
	b = (b - _tmp12_) / _tmp13_;
	_tmp14_ = max;
	if (_tmp14_ == r) {
		gdouble _tmp15_;
		_vala_h = 0 + (60 * (g - b));
		_tmp15_ = _vala_h;
		if (_tmp15_ < ((gdouble) 0)) {
			gdouble _tmp16_;
			_tmp16_ = _vala_h;
			_vala_h = _tmp16_ + 360;
		}
	} else {
		gdouble _tmp17_;
		_tmp17_ = max;
		if (_tmp17_ == g) {
			_vala_h = 120 + (60 * (b - r));
		} else {
			_vala_h = 240 + (60 * (r - g));
		}
	}
	if (h) {
		*h = _vala_h;
	}
	if (s) {
		*s = _vala_s;
	}
	if (v) {
		*v = _vala_v;
	}
}


static void
plank_color_hsv_to_rgb (gdouble h,
                        gdouble s,
                        gdouble v,
                        gdouble* r,
                        gdouble* g,
                        gdouble* b)
{
	gdouble _vala_r = 0.0;
	gdouble _vala_g = 0.0;
	gdouble _vala_b = 0.0;
	_vala_return_if_fail ((h >= ((gdouble) 0)) && (h < ((gdouble) 360)), "h >= 0 && h < 360");
	_vala_return_if_fail ((s >= ((gdouble) 0)) && (s <= ((gdouble) 1)), "s >= 0 && s <= 1");
	_vala_return_if_fail ((v >= ((gdouble) 0)) && (v <= ((gdouble) 1)), "v >= 0 && v <= 1");
	if (s == ((gdouble) 0)) {
		_vala_r = v;
		_vala_g = v;
		_vala_b = v;
	} else {
		gint secNum = 0;
		gdouble fracSec = 0.0;
		gint _tmp0_;
		gdouble p = 0.0;
		gdouble q = 0.0;
		gdouble _tmp1_;
		gdouble t = 0.0;
		gdouble _tmp2_;
		gint _tmp3_;
		secNum = (gint) (h / 60);
		_tmp0_ = secNum;
		fracSec = (h / 60.0) - _tmp0_;
		p = v * (1 - s);
		_tmp1_ = fracSec;
		q = v * (1 - (s * _tmp1_));
		_tmp2_ = fracSec;
		t = v * (1 - (s * (1 - _tmp2_)));
		_tmp3_ = secNum;
		switch (_tmp3_) {
			case 0:
			{
				gdouble _tmp4_;
				gdouble _tmp5_;
				_vala_r = v;
				_tmp4_ = t;
				_vala_g = _tmp4_;
				_tmp5_ = p;
				_vala_b = _tmp5_;
				break;
			}
			case 1:
			{
				gdouble _tmp6_;
				gdouble _tmp7_;
				_tmp6_ = q;
				_vala_r = _tmp6_;
				_vala_g = v;
				_tmp7_ = p;
				_vala_b = _tmp7_;
				break;
			}
			case 2:
			{
				gdouble _tmp8_;
				gdouble _tmp9_;
				_tmp8_ = p;
				_vala_r = _tmp8_;
				_vala_g = v;
				_tmp9_ = t;
				_vala_b = _tmp9_;
				break;
			}
			case 3:
			{
				gdouble _tmp10_;
				gdouble _tmp11_;
				_tmp10_ = p;
				_vala_r = _tmp10_;
				_tmp11_ = q;
				_vala_g = _tmp11_;
				_vala_b = v;
				break;
			}
			case 4:
			{
				gdouble _tmp12_;
				gdouble _tmp13_;
				_tmp12_ = t;
				_vala_r = _tmp12_;
				_tmp13_ = p;
				_vala_g = _tmp13_;
				_vala_b = v;
				break;
			}
			case 5:
			{
				gdouble _tmp14_;
				gdouble _tmp15_;
				_vala_r = v;
				_tmp14_ = p;
				_vala_g = _tmp14_;
				_tmp15_ = q;
				_vala_b = _tmp15_;
				break;
			}
			default:
			{
				g_assert_not_reached ();
			}
		}
	}
	if (r) {
		*r = _vala_r;
	}
	if (g) {
		*g = _vala_g;
	}
	if (b) {
		*b = _vala_b;
	}
}


static void
plank_color_rgb_to_hsl (gdouble r,
                        gdouble g,
                        gdouble b,
                        gdouble* h,
                        gdouble* s,
                        gdouble* l)
{
	gdouble _vala_h = 0.0;
	gdouble _vala_s = 0.0;
	gdouble _vala_l = 0.0;
	gdouble max = 0.0;
	gdouble _tmp0_;
	gdouble min = 0.0;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble delta = 0.0;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_;
	gdouble _tmp13_;
	gdouble r2 = 0.0;
	gdouble _tmp14_;
	gdouble _tmp15_;
	gdouble g2 = 0.0;
	gdouble _tmp16_;
	gdouble _tmp17_;
	gdouble b2 = 0.0;
	gdouble _tmp18_;
	gdouble _tmp19_;
	gdouble _tmp20_;
	_vala_return_if_fail ((r >= ((gdouble) 0)) && (r <= ((gdouble) 1)), "r >= 0 && r <= 1");
	_vala_return_if_fail ((g >= ((gdouble) 0)) && (g <= ((gdouble) 1)), "g >= 0 && g <= 1");
	_vala_return_if_fail ((b >= ((gdouble) 0)) && (b <= ((gdouble) 1)), "b >= 0 && b <= 1");
	max = MAX (r, MAX (g, b));
	_tmp0_ = max;
	if (_tmp0_ == 0.0) {
		_vala_h = 0.0;
		_vala_s = 0.0;
		_vala_l = 0.0;
		if (h) {
			*h = _vala_h;
		}
		if (s) {
			*s = _vala_s;
		}
		if (l) {
			*l = _vala_l;
		}
		return;
	}
	min = MIN (r, MIN (g, b));
	_tmp1_ = min;
	_tmp2_ = max;
	_vala_l = (_tmp1_ + _tmp2_) / 2.0;
	_tmp3_ = _vala_l;
	if (_tmp3_ <= 0.0) {
		_vala_h = 0.0;
		_vala_s = 0.0;
		if (h) {
			*h = _vala_h;
		}
		if (s) {
			*s = _vala_s;
		}
		if (l) {
			*l = _vala_l;
		}
		return;
	}
	_tmp4_ = max;
	_tmp5_ = min;
	delta = _tmp4_ - _tmp5_;
	_tmp6_ = delta;
	if (_tmp6_ <= 0.0) {
		_vala_h = 0.0;
		_vala_s = 0.0;
		if (h) {
			*h = _vala_h;
		}
		if (s) {
			*s = _vala_s;
		}
		if (l) {
			*l = _vala_l;
		}
		return;
	}
	_tmp8_ = _vala_l;
	if (_tmp8_ <= 0.5) {
		gdouble _tmp9_;
		gdouble _tmp10_;
		_tmp9_ = min;
		_tmp10_ = max;
		_tmp7_ = _tmp9_ + _tmp10_;
	} else {
		gdouble _tmp11_;
		gdouble _tmp12_;
		_tmp11_ = min;
		_tmp12_ = max;
		_tmp7_ = (2.0 - _tmp11_) - _tmp12_;
	}
	_tmp13_ = delta;
	_vala_s = _tmp13_ / _tmp7_;
	_tmp14_ = max;
	_tmp15_ = delta;
	r2 = (60 * (_tmp14_ - r)) / _tmp15_;
	_tmp16_ = max;
	_tmp17_ = delta;
	g2 = (60 * (_tmp16_ - g)) / _tmp17_;
	_tmp18_ = max;
	_tmp19_ = delta;
	b2 = (60 * (_tmp18_ - b)) / _tmp19_;
	_tmp20_ = max;
	if (_tmp20_ == r) {
		gdouble _tmp21_;
		gdouble _tmp22_;
		gdouble _tmp23_;
		_tmp21_ = b2;
		_tmp22_ = g2;
		_vala_h = _tmp21_ - _tmp22_;
		_tmp23_ = _vala_h;
		if (_tmp23_ < ((gdouble) 0)) {
			gdouble _tmp24_;
			_tmp24_ = _vala_h;
			_vala_h = _tmp24_ + 360;
		}
	} else {
		gdouble _tmp25_;
		_tmp25_ = max;
		if (_tmp25_ == g) {
			gdouble _tmp26_;
			gdouble _tmp27_;
			_tmp26_ = r2;
			_tmp27_ = b2;
			_vala_h = 120 + (_tmp26_ - _tmp27_);
		} else {
			gdouble _tmp28_;
			gdouble _tmp29_;
			_tmp28_ = g2;
			_tmp29_ = r2;
			_vala_h = 240 + (_tmp28_ - _tmp29_);
		}
	}
	if (h) {
		*h = _vala_h;
	}
	if (s) {
		*s = _vala_s;
	}
	if (l) {
		*l = _vala_l;
	}
}


static void
plank_color_hsl_to_rgb (gdouble h,
                        gdouble s,
                        gdouble l,
                        gdouble* r,
                        gdouble* g,
                        gdouble* b)
{
	gdouble _vala_r = 0.0;
	gdouble _vala_g = 0.0;
	gdouble _vala_b = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble v = 0.0;
	gdouble _tmp1_;
	gint secNum = 0;
	gdouble fracSec = 0.0;
	gint _tmp2_;
	gdouble p = 0.0;
	gdouble _tmp3_;
	gdouble q = 0.0;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble t = 0.0;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gint _tmp9_;
	_vala_return_if_fail ((h >= ((gdouble) 0)) && (h < ((gdouble) 360)), "h >= 0 && h < 360");
	_vala_return_if_fail ((s >= ((gdouble) 0)) && (s <= ((gdouble) 1)), "s >= 0 && s <= 1");
	_vala_return_if_fail ((l >= ((gdouble) 0)) && (l <= ((gdouble) 1)), "l >= 0 && l <= 1");
	if (l <= 0.5) {
		_tmp0_ = l * (1.0 + s);
	} else {
		_tmp0_ = (l + s) - (l * s);
	}
	v = _tmp0_;
	_tmp1_ = v;
	if (_tmp1_ <= 0.0) {
		_vala_r = l;
		_vala_g = l;
		_vala_b = l;
		if (r) {
			*r = _vala_r;
		}
		if (g) {
			*g = _vala_g;
		}
		if (b) {
			*b = _vala_b;
		}
		return;
	}
	secNum = (gint) (h / 60);
	_tmp2_ = secNum;
	fracSec = (h / 30.0) - (2 * _tmp2_);
	_tmp3_ = v;
	p = l - (_tmp3_ - l);
	_tmp4_ = v;
	_tmp5_ = v;
	_tmp6_ = fracSec;
	q = _tmp4_ - ((_tmp5_ - l) * _tmp6_);
	_tmp7_ = v;
	_tmp8_ = fracSec;
	t = l + ((_tmp7_ - l) * (_tmp8_ - 1));
	_tmp9_ = secNum;
	switch (_tmp9_) {
		case 0:
		{
			gdouble _tmp10_;
			gdouble _tmp11_;
			gdouble _tmp12_;
			_tmp10_ = v;
			_vala_r = _tmp10_;
			_tmp11_ = t;
			_vala_g = _tmp11_;
			_tmp12_ = p;
			_vala_b = _tmp12_;
			break;
		}
		case 1:
		{
			gdouble _tmp13_;
			gdouble _tmp14_;
			gdouble _tmp15_;
			_tmp13_ = q;
			_vala_r = _tmp13_;
			_tmp14_ = v;
			_vala_g = _tmp14_;
			_tmp15_ = p;
			_vala_b = _tmp15_;
			break;
		}
		case 2:
		{
			gdouble _tmp16_;
			gdouble _tmp17_;
			gdouble _tmp18_;
			_tmp16_ = p;
			_vala_r = _tmp16_;
			_tmp17_ = v;
			_vala_g = _tmp17_;
			_tmp18_ = t;
			_vala_b = _tmp18_;
			break;
		}
		case 3:
		{
			gdouble _tmp19_;
			gdouble _tmp20_;
			gdouble _tmp21_;
			_tmp19_ = p;
			_vala_r = _tmp19_;
			_tmp20_ = q;
			_vala_g = _tmp20_;
			_tmp21_ = v;
			_vala_b = _tmp21_;
			break;
		}
		case 4:
		{
			gdouble _tmp22_;
			gdouble _tmp23_;
			gdouble _tmp24_;
			_tmp22_ = t;
			_vala_r = _tmp22_;
			_tmp23_ = p;
			_vala_g = _tmp23_;
			_tmp24_ = v;
			_vala_b = _tmp24_;
			break;
		}
		case 5:
		{
			gdouble _tmp25_;
			gdouble _tmp26_;
			gdouble _tmp27_;
			_tmp25_ = v;
			_vala_r = _tmp25_;
			_tmp26_ = p;
			_vala_g = _tmp26_;
			_tmp27_ = q;
			_vala_b = _tmp27_;
			break;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
	if (r) {
		*r = _vala_r;
	}
	if (g) {
		*g = _vala_g;
	}
	if (b) {
		*b = _vala_b;
	}
}


/**
 * Convert color to string formatted like "%d;;%d;;%d;;%d"
 * with numeric entries ranged in 0..255
 *
 * @return the string representation of this color
 */
gchar*
plank_color_to_prefs_string (PlankColor *self)
{
	gchar* result = NULL;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gchar* _tmp4_;
	_tmp0_ = (*self).red;
	_tmp1_ = (*self).green;
	_tmp2_ = (*self).blue;
	_tmp3_ = (*self).alpha;
	_tmp4_ = g_strdup_printf ("%d;;%d;;%d;;%d", (gint) (_tmp0_ * G_MAXUINT8), (gint) (_tmp1_ * G_MAXUINT8), (gint) (_tmp2_ * G_MAXUINT8), (gint) (_tmp3_ * G_MAXUINT8));
	result = _tmp4_;
	return result;
}


/**
 * Create new color converted from string formatted like
 * "%d;;%d;;%d;;%d" with numeric entries ranged in 0..255
 *
 * @return new {@link Color} based on the given string
 */
void
plank_color_from_prefs_string (const gchar* s,
                               PlankColor* result)
{
	gchar** parts = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint parts_length1;
	gint _parts_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** _tmp4_;
	gint _tmp4__length1;
	const gchar* _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	const gchar* _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	const gchar* _tmp11_;
	PlankColor _tmp12_ = {0};
	g_return_if_fail (s != NULL);
	_tmp1_ = _tmp0_ = g_strsplit (s, ";;", 0);
	parts = _tmp1_;
	parts_length1 = _vala_array_length (_tmp0_);
	_parts_size_ = parts_length1;
	_tmp2_ = parts;
	_tmp2__length1 = parts_length1;
	if (_tmp2__length1 != 4) {
		PlankColor _tmp3_ = {0};
		g_critical ("Color.vala:517: Malformed color string '%s'", s);
		*result = _tmp3_;
		parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
		return;
	}
	_tmp4_ = parts;
	_tmp4__length1 = parts_length1;
	_tmp5_ = _tmp4_[0];
	_tmp6_ = parts;
	_tmp6__length1 = parts_length1;
	_tmp7_ = _tmp6_[1];
	_tmp8_ = parts;
	_tmp8__length1 = parts_length1;
	_tmp9_ = _tmp8_[2];
	_tmp10_ = parts;
	_tmp10__length1 = parts_length1;
	_tmp11_ = _tmp10_[3];
	_tmp12_.red = CLAMP ((gdouble) atoi (_tmp5_), 0.0, (gdouble) G_MAXUINT8) / G_MAXUINT8;
	_tmp12_.green = CLAMP ((gdouble) atoi (_tmp7_), 0.0, (gdouble) G_MAXUINT8) / G_MAXUINT8;
	_tmp12_.blue = CLAMP ((gdouble) atoi (_tmp9_), 0.0, (gdouble) G_MAXUINT8) / G_MAXUINT8;
	_tmp12_.alpha = CLAMP ((gdouble) atoi (_tmp11_), 0.0, (gdouble) G_MAXUINT8) / G_MAXUINT8;
	*result = _tmp12_;
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
	return;
}


PlankColor*
plank_color_dup (const PlankColor* self)
{
	PlankColor* dup;
	dup = g_new0 (PlankColor, 1);
	memcpy (dup, self, sizeof (PlankColor));
	return dup;
}


void
plank_color_free (PlankColor* self)
{
	g_free (self);
}


GType
plank_color_get_type (void)
{
	static volatile gsize plank_color_type_id__volatile = 0;
	if (g_once_init_enter (&plank_color_type_id__volatile)) {
		GType plank_color_type_id;
		plank_color_type_id = g_boxed_type_register_static ("PlankColor", (GBoxedCopyFunc) plank_color_dup, (GBoxedFreeFunc) plank_color_free);
		g_once_init_leave (&plank_color_type_id__volatile, plank_color_type_id);
	}
	return plank_color_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



