/* WindowControl.c generated by valac 0.40.11, the Vala compiler
 * generated from WindowControl.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/


#include <glib.h>
#include <glib-object.h>
#include <libwnck/libwnck.h>
#include <gdk/gdk.h>
#include <libbamf/libbamf.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo.h>


#define PLANK_TYPE_STRUTS (plank_struts_get_type ())

#define PLANK_TYPE_WINDOW_CONTROL (plank_window_control_get_type ())
#define PLANK_WINDOW_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_TYPE_WINDOW_CONTROL, PlankWindowControl))
#define PLANK_WINDOW_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_TYPE_WINDOW_CONTROL, PlankWindowControlClass))
#define PLANK_IS_WINDOW_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_TYPE_WINDOW_CONTROL))
#define PLANK_IS_WINDOW_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_TYPE_WINDOW_CONTROL))
#define PLANK_WINDOW_CONTROL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_TYPE_WINDOW_CONTROL, PlankWindowControlClass))

typedef struct _PlankWindowControl PlankWindowControl;
typedef struct _PlankWindowControlClass PlankWindowControlClass;
typedef struct _PlankWindowControlPrivate PlankWindowControlPrivate;
enum  {
	PLANK_WINDOW_CONTROL_0_PROPERTY,
	PLANK_WINDOW_CONTROL_NUM_PROPERTIES
};
static GParamSpec* plank_window_control_properties[PLANK_WINDOW_CONTROL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
typedef struct _Block1Data Block1Data;

typedef enum  {
	PLANK_STRUTS_LEFT,
	PLANK_STRUTS_RIGHT,
	PLANK_STRUTS_TOP,
	PLANK_STRUTS_BOTTOM,
	PLANK_STRUTS_LEFT_START,
	PLANK_STRUTS_LEFT_END,
	PLANK_STRUTS_RIGHT_START,
	PLANK_STRUTS_RIGHT_END,
	PLANK_STRUTS_TOP_START,
	PLANK_STRUTS_TOP_END,
	PLANK_STRUTS_BOTTOM_START,
	PLANK_STRUTS_BOTTOM_END,
	PLANK_STRUTS_N_VALUES
} PlankStruts;

struct _PlankWindowControl {
	GObject parent_instance;
	PlankWindowControlPrivate * priv;
};

struct _PlankWindowControlClass {
	GObjectClass parent_class;
};

struct _Block1Data {
	int _ref_count_;
	guint32 event_time;
};


static gpointer plank_window_control_parent_class = NULL;
static guint plank_window_control_delayed_focus_timer_id;
static guint plank_window_control_delayed_focus_timer_id = 0U;
static WnckWindow* plank_window_control_delayed_focus_window;
static WnckWindow* plank_window_control_delayed_focus_window = NULL;

GType plank_struts_get_type (void) G_GNUC_CONST;
GType plank_window_control_get_type (void) G_GNUC_CONST;
#define PLANK_WINDOW_CONTROL_WINDOW_GROUP_DELAY 10000U
#define PLANK_WINDOW_CONTROL_VIEWPORT_CHANGE_DELAY 200U
static PlankWindowControl* plank_window_control_new (void);
static PlankWindowControl* plank_window_control_construct (GType object_type);
void plank_window_control_initialize (void);
static void plank_window_control_window_manager_changed (WnckScreen* screen);
static void _plank_window_control_window_manager_changed_wnck_screen_window_manager_changed (WnckScreen* _sender,
                                                                                      gpointer self);
static void plank_window_control_handle_window_closed (WnckWindow* window);
static void _plank_window_control_handle_window_closed_wnck_screen_window_closed (WnckScreen* _sender,
                                                                           WnckWindow* window,
                                                                           gpointer self);
GdkPixbuf* plank_window_control_get_app_icon (BamfApplication* app);
GdkPixbuf* plank_window_control_get_window_icon (BamfWindow* window);
gboolean plank_window_control_has_maximized_window (BamfApplication* app);
gboolean plank_window_control_has_minimized_window (BamfApplication* app);
gboolean plank_window_control_has_window_on_workspace (BamfApplication* app,
                                                       WnckWorkspace* workspace);
void plank_window_control_update_icon_regions (BamfApplication* app,
                                               GdkRectangle* rect);
void plank_window_control_close_all (BamfApplication* app,
                                     guint32 event_time);
void plank_window_control_focus_window (BamfWindow* window,
                                        guint32 event_time);
static void plank_window_control_center_and_focus_window (WnckWindow* w,
                                                   guint32 event_time);
static void plank_window_control_focus_window_by_xid (guint32 xid,
                                               guint32 event_time);
static gint plank_window_control_find_active_xid_index (GArray* xids);
void plank_window_control_focus_previous (BamfApplication* app,
                                          guint32 event_time);
void plank_window_control_focus_next (BamfApplication* app,
                                      guint32 event_time);
void plank_window_control_minimize (BamfApplication* app);
GList* plank_window_control_get_ordered_window_stack (BamfApplication* app);
void plank_window_control_restore (BamfApplication* app,
                                   guint32 event_time);
void plank_window_control_maximize (BamfApplication* app);
void plank_window_control_unmaximize (BamfApplication* app);
void plank_window_control_smart_focus (BamfApplication* app,
                                       guint32 event_time);
static void plank_window_control_intelligent_focus_off_viewport_window (WnckWindow* targetWindow,
                                                                 GList* additional_windows,
                                                                 guint32 event_time);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean plank_window_control_windows_share_viewport (WnckWindow* first,
                                                      WnckWindow* second);
static gboolean __lambda4_ (Block1Data* _data1_);
static gboolean ___lambda4__gsource_func (gpointer self);
void plank_window_control_get_easy_geometry (WnckWindow* w,
                                             GdkRectangle* result);
static void plank_window_control_finalize (GObject * obj);


GType
plank_struts_get_type (void)
{
	static volatile gsize plank_struts_type_id__volatile = 0;
	if (g_once_init_enter (&plank_struts_type_id__volatile)) {
		static const GEnumValue values[] = {{PLANK_STRUTS_LEFT, "PLANK_STRUTS_LEFT", "left"}, {PLANK_STRUTS_RIGHT, "PLANK_STRUTS_RIGHT", "right"}, {PLANK_STRUTS_TOP, "PLANK_STRUTS_TOP", "top"}, {PLANK_STRUTS_BOTTOM, "PLANK_STRUTS_BOTTOM", "bottom"}, {PLANK_STRUTS_LEFT_START, "PLANK_STRUTS_LEFT_START", "left-start"}, {PLANK_STRUTS_LEFT_END, "PLANK_STRUTS_LEFT_END", "left-end"}, {PLANK_STRUTS_RIGHT_START, "PLANK_STRUTS_RIGHT_START", "right-start"}, {PLANK_STRUTS_RIGHT_END, "PLANK_STRUTS_RIGHT_END", "right-end"}, {PLANK_STRUTS_TOP_START, "PLANK_STRUTS_TOP_START", "top-start"}, {PLANK_STRUTS_TOP_END, "PLANK_STRUTS_TOP_END", "top-end"}, {PLANK_STRUTS_BOTTOM_START, "PLANK_STRUTS_BOTTOM_START", "bottom-start"}, {PLANK_STRUTS_BOTTOM_END, "PLANK_STRUTS_BOTTOM_END", "bottom-end"}, {PLANK_STRUTS_N_VALUES, "PLANK_STRUTS_N_VALUES", "n-values"}, {0, NULL, NULL}};
		GType plank_struts_type_id;
		plank_struts_type_id = g_enum_register_static ("PlankStruts", values);
		g_once_init_leave (&plank_struts_type_id__volatile, plank_struts_type_id);
	}
	return plank_struts_type_id__volatile;
}


static PlankWindowControl*
plank_window_control_construct (GType object_type)
{
	PlankWindowControl * self = NULL;
	self = (PlankWindowControl*) g_object_new (object_type, NULL);
	return self;
}


static PlankWindowControl*
plank_window_control_new (void)
{
	return plank_window_control_construct (PLANK_TYPE_WINDOW_CONTROL);
}


static void
_plank_window_control_window_manager_changed_wnck_screen_window_manager_changed (WnckScreen* _sender,
                                                                                 gpointer self)
{
	plank_window_control_window_manager_changed (_sender);
}


static void
_plank_window_control_handle_window_closed_wnck_screen_window_closed (WnckScreen* _sender,
                                                                      WnckWindow* window,
                                                                      gpointer self)
{
	plank_window_control_handle_window_closed (window);
}


void
plank_window_control_initialize (void)
{
	WnckScreen* screen = NULL;
	WnckScreen* _tmp0_;
	WnckScreen* _tmp1_;
	WnckScreen* _tmp2_;
	WnckScreen* _tmp3_;
	WnckScreen* _tmp4_;
	const gchar* _tmp5_;
	_tmp0_ = wnck_screen_get_default ();
	screen = _tmp0_;
	wnck_set_client_type (WNCK_CLIENT_TYPE_PAGER);
	gdk_error_trap_push ();
	_tmp1_ = screen;
	wnck_screen_force_update (_tmp1_);
	if (gdk_error_trap_pop () != 0) {
		g_critical ("WindowControl.vala:63: Wnck.Screen.force_update() caused a XError");
	}
	_tmp2_ = screen;
	g_signal_connect_after (_tmp2_, "window-manager-changed", (GCallback) _plank_window_control_window_manager_changed_wnck_screen_window_manager_changed, NULL);
	_tmp3_ = screen;
	g_signal_connect_after (_tmp3_, "window-closed", (GCallback) _plank_window_control_handle_window_closed_wnck_screen_window_closed, NULL);
	_tmp4_ = screen;
	_tmp5_ = wnck_screen_get_window_manager_name (_tmp4_);
	g_message ("WindowControl.vala:68: Window-manager: %s", _tmp5_);
}


static void
plank_window_control_window_manager_changed (WnckScreen* screen)
{
	const gchar* _tmp0_;
	g_return_if_fail (screen != NULL);
	gdk_error_trap_push ();
	wnck_screen_force_update (screen);
	if (gdk_error_trap_pop () != 0) {
		g_critical ("WindowControl.vala:77: Wnck.Screen.force_update() caused a XError");
	}
	_tmp0_ = wnck_screen_get_window_manager_name (screen);
	g_warning ("WindowControl.vala:79: Window-manager changed: %s", _tmp0_);
}


static void
plank_window_control_handle_window_closed (WnckWindow* window)
{
	gboolean _tmp0_ = FALSE;
	guint _tmp1_;
	g_return_if_fail (window != NULL);
	_tmp1_ = plank_window_control_delayed_focus_timer_id;
	if (_tmp1_ > 0U) {
		WnckWindow* _tmp2_;
		_tmp2_ = plank_window_control_delayed_focus_window;
		_tmp0_ = _tmp2_ == window;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		guint _tmp3_;
		_tmp3_ = plank_window_control_delayed_focus_timer_id;
		g_source_remove (_tmp3_);
		plank_window_control_delayed_focus_timer_id = 0U;
		_g_object_unref0 (plank_window_control_delayed_focus_window);
		plank_window_control_delayed_focus_window = NULL;
	}
}


GdkPixbuf*
plank_window_control_get_app_icon (BamfApplication* app)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* pbuf = NULL;
	GArray* xids = NULL;
	GArray* _tmp0_;
	GArray* _tmp1_;
	GdkPixbuf* _tmp20_;
	g_return_val_if_fail (app != NULL, NULL);
	pbuf = NULL;
	wnck_screen_get_default ();
	_tmp0_ = bamf_application_get_xids (app);
	xids = _tmp0_;
	_tmp1_ = xids;
	g_warn_if_fail (_tmp1_ != NULL);
	gdk_error_trap_push ();
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
				GArray* _tmp6_;
				WnckWindow* window = NULL;
				GArray* _tmp11_;
				gint _tmp12_;
				WnckWindow* _tmp13_;
				WnckWindow* _tmp14_;
				WnckWindow* _tmp15_;
				GdkPixbuf* _tmp16_;
				WnckWindow* _tmp17_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp6_ = xids;
				if (_tmp6_ != NULL) {
					gint _tmp7_;
					GArray* _tmp8_;
					guint _tmp9_;
					_tmp7_ = i;
					_tmp8_ = xids;
					_tmp9_ = _tmp8_->len;
					_tmp5_ = ((guint) _tmp7_) < _tmp9_;
				} else {
					_tmp5_ = FALSE;
				}
				if (_tmp5_) {
					GdkPixbuf* _tmp10_;
					_tmp10_ = pbuf;
					_tmp4_ = _tmp10_ == NULL;
				} else {
					_tmp4_ = FALSE;
				}
				if (!_tmp4_) {
					break;
				}
				_tmp11_ = xids;
				_tmp12_ = i;
				_tmp13_ = wnck_window_get ((gulong) g_array_index (_tmp11_, guint32, (guint) _tmp12_));
				window = _tmp13_;
				_tmp14_ = window;
				if (_tmp14_ == NULL) {
					continue;
				}
				_tmp15_ = window;
				_tmp16_ = wnck_window_get_icon (_tmp15_);
				pbuf = _tmp16_;
				_tmp17_ = window;
				if (wnck_window_get_icon_is_fallback (_tmp17_)) {
					pbuf = NULL;
				}
				break;
			}
		}
	}
	if (gdk_error_trap_pop () != 0) {
		gchar* _tmp18_;
		gchar* _tmp19_;
		_tmp18_ = bamf_view_get_name ((BamfView*) app);
		_tmp19_ = _tmp18_;
		g_critical ("WindowControl.vala:115: get_app_icon() for '%s' caused a XError", _tmp19_);
		_g_free0 (_tmp19_);
	}
	_tmp20_ = pbuf;
	result = _tmp20_;
	_g_array_unref0 (xids);
	return result;
}


GdkPixbuf*
plank_window_control_get_window_icon (BamfWindow* window)
{
	GdkPixbuf* result = NULL;
	WnckWindow* w = NULL;
	WnckWindow* _tmp0_;
	GdkPixbuf* pbuf = NULL;
	WnckWindow* _tmp1_;
	WnckWindow* _tmp2_;
	WnckWindow* _tmp3_;
	GdkPixbuf* _tmp4_;
	WnckWindow* _tmp5_;
	GdkPixbuf* _tmp8_;
	g_return_val_if_fail (window != NULL, NULL);
	_tmp0_ = wnck_window_get ((gulong) bamf_window_get_xid (window));
	w = _tmp0_;
	pbuf = NULL;
	_tmp1_ = w;
	g_warn_if_fail (_tmp1_ != NULL);
	_tmp2_ = w;
	if (_tmp2_ == NULL) {
		result = NULL;
		return result;
	}
	gdk_error_trap_push ();
	_tmp3_ = w;
	_tmp4_ = wnck_window_get_icon (_tmp3_);
	pbuf = _tmp4_;
	_tmp5_ = w;
	if (wnck_window_get_icon_is_fallback (_tmp5_)) {
		pbuf = NULL;
	}
	if (gdk_error_trap_pop () != 0) {
		gchar* _tmp6_;
		gchar* _tmp7_;
		_tmp6_ = bamf_view_get_name ((BamfView*) window);
		_tmp7_ = _tmp6_;
		g_critical ("WindowControl.vala:137: get_window_icon() for '%s' caused a XError", _tmp7_);
		_g_free0 (_tmp7_);
	}
	_tmp8_ = pbuf;
	result = _tmp8_;
	return result;
}


gboolean
plank_window_control_has_maximized_window (BamfApplication* app)
{
	gboolean result = FALSE;
	GArray* xids = NULL;
	GArray* _tmp0_;
	GArray* _tmp1_;
	g_return_val_if_fail (app != NULL, FALSE);
	wnck_screen_get_default ();
	_tmp0_ = bamf_application_get_xids (app);
	xids = _tmp0_;
	_tmp1_ = xids;
	g_warn_if_fail (_tmp1_ != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				gboolean _tmp4_ = FALSE;
				GArray* _tmp5_;
				WnckWindow* window = NULL;
				GArray* _tmp9_;
				gint _tmp10_;
				WnckWindow* _tmp11_;
				gboolean _tmp12_ = FALSE;
				WnckWindow* _tmp13_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp5_ = xids;
				if (_tmp5_ != NULL) {
					gint _tmp6_;
					GArray* _tmp7_;
					guint _tmp8_;
					_tmp6_ = i;
					_tmp7_ = xids;
					_tmp8_ = _tmp7_->len;
					_tmp4_ = ((guint) _tmp6_) < _tmp8_;
				} else {
					_tmp4_ = FALSE;
				}
				if (!_tmp4_) {
					break;
				}
				_tmp9_ = xids;
				_tmp10_ = i;
				_tmp11_ = wnck_window_get ((gulong) g_array_index (_tmp9_, guint32, (guint) _tmp10_));
				window = _tmp11_;
				_tmp13_ = window;
				if (_tmp13_ != NULL) {
					WnckWindow* _tmp14_;
					_tmp14_ = window;
					_tmp12_ = wnck_window_is_maximized (_tmp14_);
				} else {
					_tmp12_ = FALSE;
				}
				if (_tmp12_) {
					result = TRUE;
					_g_array_unref0 (xids);
					return result;
				}
			}
		}
	}
	result = FALSE;
	_g_array_unref0 (xids);
	return result;
}


gboolean
plank_window_control_has_minimized_window (BamfApplication* app)
{
	gboolean result = FALSE;
	GArray* xids = NULL;
	GArray* _tmp0_;
	GArray* _tmp1_;
	g_return_val_if_fail (app != NULL, FALSE);
	wnck_screen_get_default ();
	_tmp0_ = bamf_application_get_xids (app);
	xids = _tmp0_;
	_tmp1_ = xids;
	g_warn_if_fail (_tmp1_ != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				gboolean _tmp4_ = FALSE;
				GArray* _tmp5_;
				WnckWindow* window = NULL;
				GArray* _tmp9_;
				gint _tmp10_;
				WnckWindow* _tmp11_;
				gboolean _tmp12_ = FALSE;
				WnckWindow* _tmp13_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp5_ = xids;
				if (_tmp5_ != NULL) {
					gint _tmp6_;
					GArray* _tmp7_;
					guint _tmp8_;
					_tmp6_ = i;
					_tmp7_ = xids;
					_tmp8_ = _tmp7_->len;
					_tmp4_ = ((guint) _tmp6_) < _tmp8_;
				} else {
					_tmp4_ = FALSE;
				}
				if (!_tmp4_) {
					break;
				}
				_tmp9_ = xids;
				_tmp10_ = i;
				_tmp11_ = wnck_window_get ((gulong) g_array_index (_tmp9_, guint32, (guint) _tmp10_));
				window = _tmp11_;
				_tmp13_ = window;
				if (_tmp13_ != NULL) {
					WnckWindow* _tmp14_;
					_tmp14_ = window;
					_tmp12_ = wnck_window_is_minimized (_tmp14_);
				} else {
					_tmp12_ = FALSE;
				}
				if (_tmp12_) {
					result = TRUE;
					_g_array_unref0 (xids);
					return result;
				}
			}
		}
	}
	result = FALSE;
	_g_array_unref0 (xids);
	return result;
}


gboolean
plank_window_control_has_window_on_workspace (BamfApplication* app,
                                              WnckWorkspace* workspace)
{
	gboolean result = FALSE;
	GArray* xids = NULL;
	GArray* _tmp0_;
	GArray* _tmp1_;
	gboolean is_virtual = FALSE;
	g_return_val_if_fail (app != NULL, FALSE);
	g_return_val_if_fail (workspace != NULL, FALSE);
	wnck_screen_get_default ();
	_tmp0_ = bamf_application_get_xids (app);
	xids = _tmp0_;
	_tmp1_ = xids;
	g_warn_if_fail (_tmp1_ != NULL);
	is_virtual = wnck_workspace_is_virtual (workspace);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				gboolean _tmp4_ = FALSE;
				GArray* _tmp5_;
				WnckWindow* window = NULL;
				GArray* _tmp9_;
				gint _tmp10_;
				WnckWindow* _tmp11_;
				WnckWindow* _tmp12_;
				gboolean _tmp13_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp5_ = xids;
				if (_tmp5_ != NULL) {
					gint _tmp6_;
					GArray* _tmp7_;
					guint _tmp8_;
					_tmp6_ = i;
					_tmp7_ = xids;
					_tmp8_ = _tmp7_->len;
					_tmp4_ = ((guint) _tmp6_) < _tmp8_;
				} else {
					_tmp4_ = FALSE;
				}
				if (!_tmp4_) {
					break;
				}
				_tmp9_ = xids;
				_tmp10_ = i;
				_tmp11_ = wnck_window_get ((gulong) g_array_index (_tmp9_, guint32, (guint) _tmp10_));
				window = _tmp11_;
				_tmp12_ = window;
				if (_tmp12_ == NULL) {
					continue;
				}
				_tmp13_ = is_virtual;
				if (!_tmp13_) {
					WnckWindow* _tmp14_;
					_tmp14_ = window;
					if (wnck_window_is_on_workspace (_tmp14_, workspace)) {
						result = TRUE;
						_g_array_unref0 (xids);
						return result;
					}
				} else {
					WnckWindow* _tmp15_;
					_tmp15_ = window;
					if (wnck_window_is_in_viewport (_tmp15_, workspace)) {
						result = TRUE;
						_g_array_unref0 (xids);
						return result;
					}
				}
			}
		}
	}
	result = FALSE;
	_g_array_unref0 (xids);
	return result;
}


void
plank_window_control_update_icon_regions (BamfApplication* app,
                                          GdkRectangle* rect)
{
	GArray* xids = NULL;
	GArray* _tmp0_;
	GArray* _tmp1_;
	g_return_if_fail (app != NULL);
	g_return_if_fail (rect != NULL);
	wnck_screen_get_default ();
	_tmp0_ = bamf_application_get_xids (app);
	xids = _tmp0_;
	_tmp1_ = xids;
	g_warn_if_fail (_tmp1_ != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				gboolean _tmp4_ = FALSE;
				GArray* _tmp5_;
				WnckWindow* window = NULL;
				GArray* _tmp9_;
				gint _tmp10_;
				WnckWindow* _tmp11_;
				WnckWindow* _tmp12_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp5_ = xids;
				if (_tmp5_ != NULL) {
					gint _tmp6_;
					GArray* _tmp7_;
					guint _tmp8_;
					_tmp6_ = i;
					_tmp7_ = xids;
					_tmp8_ = _tmp7_->len;
					_tmp4_ = ((guint) _tmp6_) < _tmp8_;
				} else {
					_tmp4_ = FALSE;
				}
				if (!_tmp4_) {
					break;
				}
				_tmp9_ = xids;
				_tmp10_ = i;
				_tmp11_ = wnck_window_get ((gulong) g_array_index (_tmp9_, guint32, (guint) _tmp10_));
				window = _tmp11_;
				_tmp12_ = window;
				if (_tmp12_ != NULL) {
					WnckWindow* _tmp13_;
					GdkRectangle _tmp14_;
					gint _tmp15_;
					GdkRectangle _tmp16_;
					gint _tmp17_;
					GdkRectangle _tmp18_;
					gint _tmp19_;
					GdkRectangle _tmp20_;
					gint _tmp21_;
					_tmp13_ = window;
					_tmp14_ = *rect;
					_tmp15_ = _tmp14_.x;
					_tmp16_ = *rect;
					_tmp17_ = _tmp16_.y;
					_tmp18_ = *rect;
					_tmp19_ = _tmp18_.width;
					_tmp20_ = *rect;
					_tmp21_ = _tmp20_.height;
					wnck_window_set_icon_geometry (_tmp13_, _tmp15_, _tmp17_, _tmp19_, _tmp21_);
				}
			}
		}
	}
	_g_array_unref0 (xids);
}


void
plank_window_control_close_all (BamfApplication* app,
                                guint32 event_time)
{
	GArray* xids = NULL;
	GArray* _tmp0_;
	GArray* _tmp1_;
	g_return_if_fail (app != NULL);
	wnck_screen_get_default ();
	_tmp0_ = bamf_application_get_xids (app);
	xids = _tmp0_;
	_tmp1_ = xids;
	g_warn_if_fail (_tmp1_ != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				gboolean _tmp4_ = FALSE;
				GArray* _tmp5_;
				WnckWindow* window = NULL;
				GArray* _tmp9_;
				gint _tmp10_;
				WnckWindow* _tmp11_;
				gboolean _tmp12_ = FALSE;
				WnckWindow* _tmp13_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp5_ = xids;
				if (_tmp5_ != NULL) {
					gint _tmp6_;
					GArray* _tmp7_;
					guint _tmp8_;
					_tmp6_ = i;
					_tmp7_ = xids;
					_tmp8_ = _tmp7_->len;
					_tmp4_ = ((guint) _tmp6_) < _tmp8_;
				} else {
					_tmp4_ = FALSE;
				}
				if (!_tmp4_) {
					break;
				}
				_tmp9_ = xids;
				_tmp10_ = i;
				_tmp11_ = wnck_window_get ((gulong) g_array_index (_tmp9_, guint32, (guint) _tmp10_));
				window = _tmp11_;
				_tmp13_ = window;
				if (_tmp13_ != NULL) {
					WnckWindow* _tmp14_;
					_tmp14_ = window;
					_tmp12_ = !wnck_window_is_skip_tasklist (_tmp14_);
				} else {
					_tmp12_ = FALSE;
				}
				if (_tmp12_) {
					WnckWindow* _tmp15_;
					_tmp15_ = window;
					wnck_window_close (_tmp15_, event_time);
				}
			}
		}
	}
	_g_array_unref0 (xids);
}


void
plank_window_control_focus_window (BamfWindow* window,
                                   guint32 event_time)
{
	WnckWindow* w = NULL;
	WnckWindow* _tmp0_;
	WnckWindow* _tmp1_;
	WnckWindow* _tmp2_;
	WnckWindow* _tmp3_;
	g_return_if_fail (window != NULL);
	wnck_screen_get_default ();
	_tmp0_ = wnck_window_get ((gulong) bamf_window_get_xid (window));
	w = _tmp0_;
	_tmp1_ = w;
	g_warn_if_fail (_tmp1_ != NULL);
	_tmp2_ = w;
	if (_tmp2_ == NULL) {
		return;
	}
	_tmp3_ = w;
	plank_window_control_center_and_focus_window (_tmp3_, event_time);
}


static void
plank_window_control_focus_window_by_xid (guint32 xid,
                                          guint32 event_time)
{
	WnckWindow* w = NULL;
	WnckWindow* _tmp0_;
	WnckWindow* _tmp1_;
	WnckWindow* _tmp2_;
	WnckWindow* _tmp3_;
	wnck_screen_get_default ();
	_tmp0_ = wnck_window_get ((gulong) xid);
	w = _tmp0_;
	_tmp1_ = w;
	g_warn_if_fail (_tmp1_ != NULL);
	_tmp2_ = w;
	if (_tmp2_ == NULL) {
		return;
	}
	_tmp3_ = w;
	plank_window_control_center_and_focus_window (_tmp3_, event_time);
}


static gint
plank_window_control_find_active_xid_index (GArray* xids)
{
	gint result = 0;
	gint i = 0;
	i = 0;
	{
		gboolean _tmp0_ = FALSE;
		_tmp0_ = TRUE;
		while (TRUE) {
			gboolean _tmp2_ = FALSE;
			WnckWindow* window = NULL;
			gint _tmp5_;
			WnckWindow* _tmp6_;
			gboolean _tmp7_ = FALSE;
			WnckWindow* _tmp8_;
			if (!_tmp0_) {
				gint _tmp1_;
				_tmp1_ = i;
				i = _tmp1_ + 1;
			}
			_tmp0_ = FALSE;
			if (xids != NULL) {
				gint _tmp3_;
				guint _tmp4_;
				_tmp3_ = i;
				_tmp4_ = xids->len;
				_tmp2_ = ((guint) _tmp3_) < _tmp4_;
			} else {
				_tmp2_ = FALSE;
			}
			if (!_tmp2_) {
				break;
			}
			_tmp5_ = i;
			_tmp6_ = wnck_window_get ((gulong) g_array_index (xids, guint32, (guint) _tmp5_));
			window = _tmp6_;
			_tmp8_ = window;
			if (_tmp8_ != NULL) {
				WnckWindow* _tmp9_;
				_tmp9_ = window;
				_tmp7_ = wnck_window_is_active (_tmp9_);
			} else {
				_tmp7_ = FALSE;
			}
			if (_tmp7_) {
				break;
			}
		}
	}
	result = i;
	return result;
}


void
plank_window_control_focus_previous (BamfApplication* app,
                                     guint32 event_time)
{
	GArray* xids = NULL;
	GArray* _tmp0_;
	GArray* _tmp1_;
	GArray* _tmp2_;
	gint i = 0;
	GArray* _tmp3_;
	gint _tmp4_ = 0;
	gint _tmp5_;
	GArray* _tmp6_;
	guint _tmp7_;
	gint _tmp9_;
	GArray* _tmp12_;
	gint _tmp13_;
	g_return_if_fail (app != NULL);
	wnck_screen_get_default ();
	_tmp0_ = bamf_application_get_xids (app);
	xids = _tmp0_;
	_tmp1_ = xids;
	g_warn_if_fail (_tmp1_ != NULL);
	_tmp2_ = xids;
	if (_tmp2_ == NULL) {
		_g_array_unref0 (xids);
		return;
	}
	_tmp3_ = xids;
	i = plank_window_control_find_active_xid_index (_tmp3_);
	_tmp5_ = i;
	_tmp6_ = xids;
	_tmp7_ = _tmp6_->len;
	if (((guint) _tmp5_) < _tmp7_) {
		gint _tmp8_;
		_tmp8_ = i;
		_tmp4_ = _tmp8_ - 1;
	} else {
		_tmp4_ = 0;
	}
	i = _tmp4_;
	_tmp9_ = i;
	if (_tmp9_ < 0) {
		GArray* _tmp10_;
		guint _tmp11_;
		_tmp10_ = xids;
		_tmp11_ = _tmp10_->len;
		i = ((gint) _tmp11_) - 1;
	}
	_tmp12_ = xids;
	_tmp13_ = i;
	plank_window_control_focus_window_by_xid (g_array_index (_tmp12_, guint32, (guint) _tmp13_), event_time);
	_g_array_unref0 (xids);
}


void
plank_window_control_focus_next (BamfApplication* app,
                                 guint32 event_time)
{
	GArray* xids = NULL;
	GArray* _tmp0_;
	GArray* _tmp1_;
	GArray* _tmp2_;
	gint i = 0;
	GArray* _tmp3_;
	gint _tmp4_ = 0;
	gint _tmp5_;
	GArray* _tmp6_;
	guint _tmp7_;
	gint _tmp9_;
	GArray* _tmp10_;
	guint _tmp11_;
	GArray* _tmp12_;
	gint _tmp13_;
	g_return_if_fail (app != NULL);
	wnck_screen_get_default ();
	_tmp0_ = bamf_application_get_xids (app);
	xids = _tmp0_;
	_tmp1_ = xids;
	g_warn_if_fail (_tmp1_ != NULL);
	_tmp2_ = xids;
	if (_tmp2_ == NULL) {
		_g_array_unref0 (xids);
		return;
	}
	_tmp3_ = xids;
	i = plank_window_control_find_active_xid_index (_tmp3_);
	_tmp5_ = i;
	_tmp6_ = xids;
	_tmp7_ = _tmp6_->len;
	if (((guint) _tmp5_) < _tmp7_) {
		gint _tmp8_;
		_tmp8_ = i;
		_tmp4_ = _tmp8_ + 1;
	} else {
		_tmp4_ = 0;
	}
	i = _tmp4_;
	_tmp9_ = i;
	_tmp10_ = xids;
	_tmp11_ = _tmp10_->len;
	if (((guint) _tmp9_) == _tmp11_) {
		i = 0;
	}
	_tmp12_ = xids;
	_tmp13_ = i;
	plank_window_control_focus_window_by_xid (g_array_index (_tmp12_, guint32, (guint) _tmp13_), event_time);
	_g_array_unref0 (xids);
}


void
plank_window_control_minimize (BamfApplication* app)
{
	GList* _tmp0_;
	g_return_if_fail (app != NULL);
	_tmp0_ = plank_window_control_get_ordered_window_stack (app);
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp0_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				WnckWorkspace* active_workspace = NULL;
				WnckWindow* _tmp1_;
				WnckScreen* _tmp2_;
				WnckWorkspace* _tmp3_;
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
				WnckWindow* _tmp6_;
				_tmp1_ = window;
				_tmp2_ = wnck_window_get_screen (_tmp1_);
				_tmp3_ = wnck_screen_get_active_workspace (_tmp2_);
				active_workspace = _tmp3_;
				_tmp6_ = window;
				if (!wnck_window_is_minimized (_tmp6_)) {
					WnckWorkspace* _tmp7_;
					_tmp7_ = active_workspace;
					_tmp5_ = _tmp7_ != NULL;
				} else {
					_tmp5_ = FALSE;
				}
				if (_tmp5_) {
					WnckWindow* _tmp8_;
					WnckWorkspace* _tmp9_;
					_tmp8_ = window;
					_tmp9_ = active_workspace;
					_tmp4_ = wnck_window_is_in_viewport (_tmp8_, _tmp9_);
				} else {
					_tmp4_ = FALSE;
				}
				if (_tmp4_) {
					WnckWindow* _tmp10_;
					_tmp10_ = window;
					wnck_window_minimize (_tmp10_);
					g_usleep ((gulong) PLANK_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
				}
			}
		}
		(window_collection == NULL) ? NULL : (window_collection = (g_list_free (window_collection), NULL));
	}
}


void
plank_window_control_restore (BamfApplication* app,
                              guint32 event_time)
{
	GList* stack = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	g_return_if_fail (app != NULL);
	_tmp0_ = plank_window_control_get_ordered_window_stack (app);
	stack = _tmp0_;
	stack = g_list_reverse (stack);
	_tmp1_ = stack;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp1_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				WnckWorkspace* active_workspace = NULL;
				WnckWindow* _tmp2_;
				WnckScreen* _tmp3_;
				WnckWorkspace* _tmp4_;
				gboolean _tmp5_ = FALSE;
				gboolean _tmp6_ = FALSE;
				WnckWindow* _tmp7_;
				_tmp2_ = window;
				_tmp3_ = wnck_window_get_screen (_tmp2_);
				_tmp4_ = wnck_screen_get_active_workspace (_tmp3_);
				active_workspace = _tmp4_;
				_tmp7_ = window;
				if (wnck_window_is_minimized (_tmp7_)) {
					WnckWorkspace* _tmp8_;
					_tmp8_ = active_workspace;
					_tmp6_ = _tmp8_ != NULL;
				} else {
					_tmp6_ = FALSE;
				}
				if (_tmp6_) {
					WnckWindow* _tmp9_;
					WnckWorkspace* _tmp10_;
					_tmp9_ = window;
					_tmp10_ = active_workspace;
					_tmp5_ = wnck_window_is_in_viewport (_tmp9_, _tmp10_);
				} else {
					_tmp5_ = FALSE;
				}
				if (_tmp5_) {
					WnckWindow* _tmp11_;
					_tmp11_ = window;
					wnck_window_unminimize (_tmp11_, event_time);
					g_usleep ((gulong) PLANK_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
				}
			}
		}
	}
	(stack == NULL) ? NULL : (stack = (g_list_free (stack), NULL));
}


void
plank_window_control_maximize (BamfApplication* app)
{
	GList* _tmp0_;
	g_return_if_fail (app != NULL);
	_tmp0_ = plank_window_control_get_ordered_window_stack (app);
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp0_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				WnckWindow* _tmp1_;
				_tmp1_ = window;
				if (!wnck_window_is_maximized (_tmp1_)) {
					WnckWindow* _tmp2_;
					_tmp2_ = window;
					wnck_window_maximize (_tmp2_);
				}
			}
		}
		(window_collection == NULL) ? NULL : (window_collection = (g_list_free (window_collection), NULL));
	}
}


void
plank_window_control_unmaximize (BamfApplication* app)
{
	GList* _tmp0_;
	g_return_if_fail (app != NULL);
	_tmp0_ = plank_window_control_get_ordered_window_stack (app);
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp0_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				WnckWindow* _tmp1_;
				_tmp1_ = window;
				if (wnck_window_is_maximized (_tmp1_)) {
					WnckWindow* _tmp2_;
					_tmp2_ = window;
					wnck_window_unmaximize (_tmp2_);
				}
			}
		}
		(window_collection == NULL) ? NULL : (window_collection = (g_list_free (window_collection), NULL));
	}
}


GList*
plank_window_control_get_ordered_window_stack (BamfApplication* app)
{
	GList* result = NULL;
	GList* windows = NULL;
	GArray* xids = NULL;
	GArray* _tmp0_;
	GArray* _tmp1_;
	GArray* _tmp2_;
	GList* stack = NULL;
	WnckScreen* _tmp3_;
	GList* _tmp4_;
	GList* _tmp5_;
	g_return_val_if_fail (app != NULL, NULL);
	windows = NULL;
	wnck_screen_get_default ();
	_tmp0_ = bamf_application_get_xids (app);
	xids = _tmp0_;
	_tmp1_ = xids;
	g_warn_if_fail (_tmp1_ != NULL);
	_tmp2_ = xids;
	if (_tmp2_ == NULL) {
		result = windows;
		_g_array_unref0 (xids);
		return result;
	}
	_tmp3_ = wnck_screen_get_default ();
	_tmp4_ = wnck_screen_get_windows_stacked (_tmp3_);
	stack = _tmp4_;
	_tmp5_ = stack;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp5_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							gint _tmp8_;
							GArray* _tmp9_;
							guint _tmp10_;
							GArray* _tmp11_;
							gint _tmp12_;
							WnckWindow* _tmp13_;
							if (!_tmp6_) {
								gint _tmp7_;
								_tmp7_ = j;
								j = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							_tmp8_ = j;
							_tmp9_ = xids;
							_tmp10_ = _tmp9_->len;
							if (!(((guint) _tmp8_) < _tmp10_)) {
								break;
							}
							_tmp11_ = xids;
							_tmp12_ = j;
							_tmp13_ = window;
							if (((gulong) g_array_index (_tmp11_, guint32, (guint) _tmp12_)) == wnck_window_get_xid (_tmp13_)) {
								WnckWindow* _tmp14_;
								_tmp14_ = window;
								windows = g_list_append (windows, _tmp14_);
							}
						}
					}
				}
			}
		}
	}
	result = windows;
	_g_array_unref0 (xids);
	return result;
}


void
plank_window_control_smart_focus (BamfApplication* app,
                                  guint32 event_time)
{
	GList* windows = NULL;
	GList* _tmp0_;
	gboolean not_in_viewport = FALSE;
	gboolean urgent = FALSE;
	GList* _tmp1_;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_;
	GList* _tmp22_;
	GList* _tmp38_;
	GList* _tmp59_;
	GList* _tmp71_;
	gconstpointer _tmp72_;
	GList* _tmp73_;
	g_return_if_fail (app != NULL);
	_tmp0_ = plank_window_control_get_ordered_window_stack (app);
	windows = _tmp0_;
	not_in_viewport = TRUE;
	urgent = FALSE;
	_tmp1_ = windows;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp1_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				WnckWorkspace* active_workspace = NULL;
				WnckWindow* _tmp2_;
				WnckScreen* _tmp3_;
				WnckWorkspace* _tmp4_;
				gboolean _tmp5_ = FALSE;
				gboolean _tmp6_ = FALSE;
				WnckWindow* _tmp7_;
				WnckWindow* _tmp11_;
				_tmp2_ = window;
				_tmp3_ = wnck_window_get_screen (_tmp2_);
				_tmp4_ = wnck_screen_get_active_workspace (_tmp3_);
				active_workspace = _tmp4_;
				_tmp7_ = window;
				if (!wnck_window_is_skip_tasklist (_tmp7_)) {
					WnckWorkspace* _tmp8_;
					_tmp8_ = active_workspace;
					_tmp6_ = _tmp8_ != NULL;
				} else {
					_tmp6_ = FALSE;
				}
				if (_tmp6_) {
					WnckWindow* _tmp9_;
					WnckWorkspace* _tmp10_;
					_tmp9_ = window;
					_tmp10_ = active_workspace;
					_tmp5_ = wnck_window_is_in_viewport (_tmp9_, _tmp10_);
				} else {
					_tmp5_ = FALSE;
				}
				if (_tmp5_) {
					not_in_viewport = FALSE;
				}
				_tmp11_ = window;
				if (wnck_window_needs_attention (_tmp11_)) {
					urgent = TRUE;
				}
			}
		}
	}
	_tmp13_ = not_in_viewport;
	if (_tmp13_) {
		_tmp12_ = TRUE;
	} else {
		gboolean _tmp14_;
		_tmp14_ = urgent;
		_tmp12_ = _tmp14_;
	}
	if (_tmp12_) {
		GList* _tmp15_;
		_tmp15_ = windows;
		{
			GList* window_collection = NULL;
			GList* window_it = NULL;
			window_collection = _tmp15_;
			for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
				WnckWindow* window = NULL;
				window = (WnckWindow*) window_it->data;
				{
					gboolean _tmp16_ = FALSE;
					gboolean _tmp17_;
					WnckWindow* _tmp19_;
					_tmp17_ = urgent;
					if (_tmp17_) {
						WnckWindow* _tmp18_;
						_tmp18_ = window;
						_tmp16_ = !wnck_window_needs_attention (_tmp18_);
					} else {
						_tmp16_ = FALSE;
					}
					if (_tmp16_) {
						continue;
					}
					_tmp19_ = window;
					if (!wnck_window_is_skip_tasklist (_tmp19_)) {
						WnckWindow* _tmp20_;
						GList* _tmp21_;
						_tmp20_ = window;
						_tmp21_ = windows;
						plank_window_control_intelligent_focus_off_viewport_window (_tmp20_, _tmp21_, event_time);
						(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
						return;
					}
				}
			}
		}
	}
	_tmp22_ = windows;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp22_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				WnckWorkspace* active_workspace = NULL;
				WnckWindow* _tmp23_;
				WnckScreen* _tmp24_;
				WnckWorkspace* _tmp25_;
				gboolean _tmp26_ = FALSE;
				gboolean _tmp27_ = FALSE;
				WnckWindow* _tmp28_;
				_tmp23_ = window;
				_tmp24_ = wnck_window_get_screen (_tmp23_);
				_tmp25_ = wnck_screen_get_active_workspace (_tmp24_);
				active_workspace = _tmp25_;
				_tmp28_ = window;
				if (wnck_window_is_minimized (_tmp28_)) {
					WnckWorkspace* _tmp29_;
					_tmp29_ = active_workspace;
					_tmp27_ = _tmp29_ != NULL;
				} else {
					_tmp27_ = FALSE;
				}
				if (_tmp27_) {
					WnckWindow* _tmp30_;
					WnckWorkspace* _tmp31_;
					_tmp30_ = window;
					_tmp31_ = active_workspace;
					_tmp26_ = wnck_window_is_in_viewport (_tmp30_, _tmp31_);
				} else {
					_tmp26_ = FALSE;
				}
				if (_tmp26_) {
					GList* _tmp32_;
					_tmp32_ = windows;
					{
						GList* w_collection = NULL;
						GList* w_it = NULL;
						w_collection = _tmp32_;
						for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
							WnckWindow* w = NULL;
							w = (WnckWindow*) w_it->data;
							{
								gboolean _tmp33_ = FALSE;
								WnckWindow* _tmp34_;
								_tmp34_ = w;
								if (wnck_window_is_minimized (_tmp34_)) {
									WnckWindow* _tmp35_;
									WnckWorkspace* _tmp36_;
									_tmp35_ = w;
									_tmp36_ = active_workspace;
									_tmp33_ = wnck_window_is_in_viewport (_tmp35_, _tmp36_);
								} else {
									_tmp33_ = FALSE;
								}
								if (_tmp33_) {
									WnckWindow* _tmp37_;
									_tmp37_ = w;
									wnck_window_unminimize (_tmp37_, event_time);
									g_usleep ((gulong) PLANK_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
								}
							}
						}
					}
					(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
					return;
				}
			}
		}
	}
	_tmp38_ = windows;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp38_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				WnckWorkspace* active_workspace = NULL;
				WnckWindow* _tmp39_;
				WnckScreen* _tmp40_;
				WnckWorkspace* _tmp41_;
				gboolean _tmp42_ = FALSE;
				gboolean _tmp43_ = FALSE;
				gboolean _tmp44_ = FALSE;
				WnckWindow* _tmp45_;
				_tmp39_ = window;
				_tmp40_ = wnck_window_get_screen (_tmp39_);
				_tmp41_ = wnck_screen_get_active_workspace (_tmp40_);
				active_workspace = _tmp41_;
				_tmp45_ = window;
				if (wnck_window_is_active (_tmp45_)) {
					WnckWorkspace* _tmp46_;
					_tmp46_ = active_workspace;
					_tmp44_ = _tmp46_ != NULL;
				} else {
					_tmp44_ = FALSE;
				}
				if (_tmp44_) {
					WnckWindow* _tmp47_;
					WnckWorkspace* _tmp48_;
					_tmp47_ = window;
					_tmp48_ = active_workspace;
					_tmp43_ = wnck_window_is_in_viewport (_tmp47_, _tmp48_);
				} else {
					_tmp43_ = FALSE;
				}
				if (_tmp43_) {
					_tmp42_ = TRUE;
				} else {
					WnckWindow* _tmp49_;
					WnckWindow* _tmp50_;
					WnckScreen* _tmp51_;
					WnckWindow* _tmp52_;
					_tmp49_ = window;
					_tmp50_ = window;
					_tmp51_ = wnck_window_get_screen (_tmp50_);
					_tmp52_ = wnck_screen_get_active_window (_tmp51_);
					_tmp42_ = _tmp49_ == _tmp52_;
				}
				if (_tmp42_) {
					GList* _tmp53_;
					_tmp53_ = windows;
					{
						GList* w_collection = NULL;
						GList* w_it = NULL;
						w_collection = _tmp53_;
						for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
							WnckWindow* w = NULL;
							w = (WnckWindow*) w_it->data;
							{
								gboolean _tmp54_ = FALSE;
								WnckWindow* _tmp55_;
								_tmp55_ = w;
								if (!wnck_window_is_minimized (_tmp55_)) {
									WnckWindow* _tmp56_;
									WnckWorkspace* _tmp57_;
									_tmp56_ = w;
									_tmp57_ = active_workspace;
									_tmp54_ = wnck_window_is_in_viewport (_tmp56_, _tmp57_);
								} else {
									_tmp54_ = FALSE;
								}
								if (_tmp54_) {
									WnckWindow* _tmp58_;
									_tmp58_ = w;
									wnck_window_minimize (_tmp58_);
									g_usleep ((gulong) PLANK_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
								}
							}
						}
					}
					(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
					return;
				}
			}
		}
	}
	_tmp59_ = windows;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp59_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				WnckWorkspace* active_workspace = NULL;
				WnckWindow* _tmp60_;
				WnckScreen* _tmp61_;
				WnckWorkspace* _tmp62_;
				gboolean _tmp63_ = FALSE;
				WnckWorkspace* _tmp64_;
				_tmp60_ = window;
				_tmp61_ = wnck_window_get_screen (_tmp60_);
				_tmp62_ = wnck_screen_get_active_workspace (_tmp61_);
				active_workspace = _tmp62_;
				_tmp64_ = active_workspace;
				if (_tmp64_ != NULL) {
					WnckWindow* _tmp65_;
					WnckWorkspace* _tmp66_;
					_tmp65_ = window;
					_tmp66_ = active_workspace;
					_tmp63_ = wnck_window_is_in_viewport (_tmp65_, _tmp66_);
				} else {
					_tmp63_ = FALSE;
				}
				if (_tmp63_) {
					GList* _tmp67_;
					_tmp67_ = windows;
					{
						GList* w_collection = NULL;
						GList* w_it = NULL;
						w_collection = _tmp67_;
						for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
							WnckWindow* w = NULL;
							w = (WnckWindow*) w_it->data;
							{
								WnckWindow* _tmp68_;
								WnckWorkspace* _tmp69_;
								_tmp68_ = w;
								_tmp69_ = active_workspace;
								if (wnck_window_is_in_viewport (_tmp68_, _tmp69_)) {
									WnckWindow* _tmp70_;
									_tmp70_ = w;
									plank_window_control_center_and_focus_window (_tmp70_, event_time);
									g_usleep ((gulong) PLANK_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
								}
							}
						}
					}
					(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
					return;
				}
			}
		}
	}
	_tmp71_ = windows;
	_tmp72_ = g_list_nth_data (_tmp71_, (guint) 0);
	_tmp73_ = windows;
	plank_window_control_intelligent_focus_off_viewport_window ((WnckWindow*) _tmp72_, _tmp73_, event_time);
	(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
}


static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		g_slice_free (Block1Data, _data1_);
	}
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static gboolean
__lambda4_ (Block1Data* _data1_)
{
	gboolean result = FALSE;
	WnckWindow* _tmp0_;
	plank_window_control_delayed_focus_timer_id = 0U;
	_tmp0_ = plank_window_control_delayed_focus_window;
	wnck_window_activate (_tmp0_, _data1_->event_time);
	_g_object_unref0 (plank_window_control_delayed_focus_window);
	plank_window_control_delayed_focus_window = NULL;
	result = FALSE;
	return result;
}


static gboolean
___lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda4_ (self);
	return result;
}


static void
plank_window_control_intelligent_focus_off_viewport_window (WnckWindow* targetWindow,
                                                            GList* additional_windows,
                                                            guint32 event_time)
{
	Block1Data* _data1_;
	guint _tmp4_;
	WnckWindow* _tmp6_;
	g_return_if_fail (targetWindow != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->event_time = event_time;
	additional_windows = g_list_reverse (additional_windows);
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = additional_windows;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				gboolean _tmp0_ = FALSE;
				WnckWindow* _tmp1_;
				_tmp1_ = window;
				if (!wnck_window_is_minimized (_tmp1_)) {
					WnckWindow* _tmp2_;
					_tmp2_ = window;
					_tmp0_ = plank_window_control_windows_share_viewport (targetWindow, _tmp2_);
				} else {
					_tmp0_ = FALSE;
				}
				if (_tmp0_) {
					WnckWindow* _tmp3_;
					_tmp3_ = window;
					plank_window_control_center_and_focus_window (_tmp3_, _data1_->event_time);
					g_usleep ((gulong) PLANK_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
				}
			}
		}
	}
	plank_window_control_center_and_focus_window (targetWindow, _data1_->event_time);
	if (g_list_length (additional_windows) <= ((guint) 1)) {
		block1_data_unref (_data1_);
		_data1_ = NULL;
		return;
	}
	_tmp4_ = plank_window_control_delayed_focus_timer_id;
	if (_tmp4_ > 0U) {
		guint _tmp5_;
		_tmp5_ = plank_window_control_delayed_focus_timer_id;
		g_source_remove (_tmp5_);
	}
	_tmp6_ = _g_object_ref0 (targetWindow);
	_g_object_unref0 (plank_window_control_delayed_focus_window);
	plank_window_control_delayed_focus_window = _tmp6_;
	plank_window_control_delayed_focus_timer_id = gdk_threads_add_timeout (PLANK_WINDOW_CONTROL_VIEWPORT_CHANGE_DELAY, ___lambda4__gsource_func, _data1_);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}


static gboolean
plank_window_control_windows_share_viewport (WnckWindow* first,
                                             WnckWindow* second)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	WnckWorkspace* wksp = NULL;
	WnckWorkspace* _tmp1_;
	WnckWorkspace* _tmp2_;
	WnckWorkspace* _tmp4_;
	GdkRectangle firstGeo = {0};
	GdkRectangle _tmp5_ = {0};
	GdkRectangle secondGeo = {0};
	GdkRectangle _tmp6_ = {0};
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	gint _tmp13_ = 0;
	gint _tmp14_ = 0;
	gint _tmp15_;
	WnckWorkspace* _tmp16_;
	gint _tmp17_;
	WnckWorkspace* _tmp18_;
	gint _tmp19_;
	WnckWorkspace* _tmp20_;
	gint _tmp21_;
	WnckWorkspace* _tmp22_;
	gint viewportWidth = 0;
	WnckScreen* _tmp23_;
	gint viewportHeight = 0;
	WnckScreen* _tmp24_;
	gint firstViewportX = 0;
	GdkRectangle _tmp25_;
	gint _tmp26_;
	GdkRectangle _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	gint firstViewportY = 0;
	GdkRectangle _tmp31_;
	gint _tmp32_;
	GdkRectangle _tmp33_;
	gint _tmp34_;
	gint _tmp35_;
	gint _tmp36_;
	GdkRectangle viewpRect = {0};
	gint _tmp37_;
	gint _tmp38_;
	gint _tmp39_;
	gint _tmp40_;
	GdkRectangle _tmp41_ = {0};
	GdkRectangle _tmp42_;
	gboolean _tmp43_;
	if (first == NULL) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = second == NULL;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp1_ = wnck_window_get_workspace (first);
	wksp = _tmp1_;
	_tmp2_ = wksp;
	if (_tmp2_ == NULL) {
		WnckWorkspace* _tmp3_;
		_tmp3_ = wnck_window_get_workspace (second);
		wksp = _tmp3_;
	}
	_tmp4_ = wksp;
	if (_tmp4_ == NULL) {
		result = FALSE;
		return result;
	}
	firstGeo = _tmp5_;
	secondGeo = _tmp6_;
	wnck_window_get_geometry (first, &_tmp7_, &_tmp8_, &_tmp9_, &_tmp10_);
	firstGeo.x = _tmp7_;
	firstGeo.y = _tmp8_;
	firstGeo.width = _tmp9_;
	firstGeo.height = _tmp10_;
	wnck_window_get_geometry (second, &_tmp11_, &_tmp12_, &_tmp13_, &_tmp14_);
	secondGeo.x = _tmp11_;
	secondGeo.y = _tmp12_;
	secondGeo.width = _tmp13_;
	secondGeo.height = _tmp14_;
	_tmp15_ = firstGeo.x;
	_tmp16_ = wksp;
	firstGeo.x = _tmp15_ + wnck_workspace_get_viewport_x (_tmp16_);
	_tmp17_ = firstGeo.y;
	_tmp18_ = wksp;
	firstGeo.y = _tmp17_ + wnck_workspace_get_viewport_y (_tmp18_);
	_tmp19_ = secondGeo.x;
	_tmp20_ = wksp;
	secondGeo.x = _tmp19_ + wnck_workspace_get_viewport_x (_tmp20_);
	_tmp21_ = secondGeo.y;
	_tmp22_ = wksp;
	secondGeo.y = _tmp21_ + wnck_workspace_get_viewport_y (_tmp22_);
	_tmp23_ = wnck_window_get_screen (first);
	viewportWidth = wnck_screen_get_width (_tmp23_);
	_tmp24_ = wnck_window_get_screen (first);
	viewportHeight = wnck_screen_get_height (_tmp24_);
	_tmp25_ = firstGeo;
	_tmp26_ = _tmp25_.x;
	_tmp27_ = firstGeo;
	_tmp28_ = _tmp27_.width;
	_tmp29_ = viewportWidth;
	_tmp30_ = viewportWidth;
	firstViewportX = ((_tmp26_ + (_tmp28_ / 2)) / _tmp29_) * _tmp30_;
	_tmp31_ = firstGeo;
	_tmp32_ = _tmp31_.y;
	_tmp33_ = firstGeo;
	_tmp34_ = _tmp33_.height;
	_tmp35_ = viewportHeight;
	_tmp36_ = viewportHeight;
	firstViewportY = ((_tmp32_ + (_tmp34_ / 2)) / _tmp35_) * _tmp36_;
	_tmp37_ = firstViewportX;
	_tmp38_ = firstViewportY;
	_tmp39_ = viewportWidth;
	_tmp40_ = viewportHeight;
	_tmp41_.x = _tmp37_;
	_tmp41_.y = _tmp38_;
	_tmp41_.width = _tmp39_;
	_tmp41_.height = _tmp40_;
	viewpRect = _tmp41_;
	_tmp42_ = secondGeo;
	_tmp43_ = gdk_rectangle_intersect (&viewpRect, &_tmp42_, NULL);
	result = _tmp43_;
	return result;
}


static void
plank_window_control_center_and_focus_window (WnckWindow* w,
                                              guint32 event_time)
{
	WnckWorkspace* workspace = NULL;
	WnckWorkspace* _tmp0_;
	gboolean _tmp1_ = FALSE;
	WnckWorkspace* _tmp2_;
	g_return_if_fail (w != NULL);
	_tmp0_ = wnck_window_get_workspace (w);
	workspace = _tmp0_;
	_tmp2_ = workspace;
	if (_tmp2_ != NULL) {
		WnckWorkspace* _tmp3_;
		WnckScreen* _tmp4_;
		WnckWorkspace* _tmp5_;
		_tmp3_ = workspace;
		_tmp4_ = wnck_window_get_screen (w);
		_tmp5_ = wnck_screen_get_active_workspace (_tmp4_);
		_tmp1_ = _tmp3_ != _tmp5_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		WnckWorkspace* _tmp6_;
		_tmp6_ = workspace;
		wnck_workspace_activate (_tmp6_, event_time);
	}
	if (wnck_window_is_minimized (w)) {
		wnck_window_unminimize (w, event_time);
	}
	wnck_window_activate_transient (w, event_time);
}


void
plank_window_control_get_easy_geometry (WnckWindow* w,
                                        GdkRectangle* result)
{
	GdkRectangle geo = {0};
	GdkRectangle _tmp0_ = {0};
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	g_return_if_fail (w != NULL);
	geo = _tmp0_;
	wnck_window_get_geometry (w, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_);
	geo.x = _tmp1_;
	geo.y = _tmp2_;
	geo.width = _tmp3_;
	geo.height = _tmp4_;
	*result = geo;
	return;
}


static void
plank_window_control_class_init (PlankWindowControlClass * klass)
{
	plank_window_control_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = plank_window_control_finalize;
}


static void
plank_window_control_instance_init (PlankWindowControl * self)
{
}


static void
plank_window_control_finalize (GObject * obj)
{
	PlankWindowControl * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_WINDOW_CONTROL, PlankWindowControl);
	G_OBJECT_CLASS (plank_window_control_parent_class)->finalize (obj);
}


GType
plank_window_control_get_type (void)
{
	static volatile gsize plank_window_control_type_id__volatile = 0;
	if (g_once_init_enter (&plank_window_control_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankWindowControlClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_window_control_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankWindowControl), 0, (GInstanceInitFunc) plank_window_control_instance_init, NULL };
		GType plank_window_control_type_id;
		plank_window_control_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankWindowControl", &g_define_type_info, 0);
		g_once_init_leave (&plank_window_control_type_id__volatile, plank_window_control_type_id);
	}
	return plank_window_control_type_id__volatile;
}



